*** empty log message ***
[glibc.git] / elf / ldd.bash.in
blob7e9fef9fd2681885911ee0a6f7537d35cce8b79f
1 #! @BASH@
2 # Copyright (C) 1996-2001, 2002, 2003 Free Software Foundation, Inc.
3 # This file is part of the GNU C Library.
5 # The GNU C Library is free software; you can redistribute it and/or
6 # modify it under the terms of the GNU Lesser General Public
7 # License as published by the Free Software Foundation; either
8 # version 2.1 of the License, or (at your option) any later version.
10 # The GNU C Library is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
13 # Lesser General Public License for more details.
15 # You should have received a copy of the GNU Lesser General Public
16 # License along with the GNU C Library; if not, write to the Free
17 # Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
18 # 02111-1307 USA.
21 # This is the `ldd' command, which lists what shared libraries are
22 # used by given dynamically-linked executables. It works by invoking the
23 # run-time dynamic linker as a command and setting the environment
24 # variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
26 # We should be able to find the translation right at the beginning.
27 TEXTDOMAIN=libc
28 TEXTDOMAINDIR=@TEXTDOMAINDIR@
30 RTLDLIST=@RTLD@
31 warn=
32 bind_now=
33 verbose=
35 while test $# -gt 0; do
36 case "$1" in
37 --vers | --versi | --versio | --version)
38 echo 'ldd (GNU libc) @VERSION@'
39 echo $"Copyright (C) 2003 Free Software Foundation, Inc.
40 This is free software; see the source for copying conditions. There is NO
41 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
42 Written by Roland McGrath and Ulrich Drepper."
43 exit 0
45 --h | --he | --hel | --help)
46 echo $"Usage: ldd [OPTION]... FILE...
47 --help print this help and exit
48 --version print version information and exit
49 -d, --data-relocs process data relocations
50 -r, --function-relocs process data and function relocations
51 -v, --verbose print all information
52 Report bugs using the \`glibcbug' script to <bugs@gnu.org>."
53 exit 0
55 -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
56 --data-rel | --data-relo | --data-reloc | --data-relocs)
57 warn=yes
58 shift
60 -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
61 --function | --function- | --function-r | --function-re | --function-rel | \
62 --function-relo | --function-reloc | --function-relocs)
63 warn=yes
64 bind_now=yes
65 shift
67 -v | --verb | --verbo | --verbos | --verbose)
68 verbose=yes
69 shift
71 --v | --ve | --ver)
72 echo >&2 $"ldd: option \`$1' is ambiguous"
73 exit 1
75 --) # Stop option processing.
76 shift; break
78 -*)
79 echo >&2 'ldd:' $"unrecognized option" "\`$1'"
80 echo >&2 $"Try \`ldd --help' for more information."
81 exit 1
84 break
86 esac
87 done
89 nonelf ()
91 # Maybe extra code for non-ELF binaries.
92 return 1;
95 add_env="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"
96 add_env="$add_env LD_VERBOSE=$verbose"
97 case $# in
99 echo >&2 'ldd:' $"missing file arguments"
100 echo >&2 $"Try \`ldd --help' for more information."
101 exit 1
104 single_file=t
107 single_file=f
109 esac
111 result=0
112 for file do
113 # We don't list the file name when there is only one.
114 test $single_file = t || echo "${file}:"
115 case $file in
116 */*) :
118 *) file=./$file
120 esac
121 if test ! -f "$file"; then
122 echo "ldd: ${file}:" $"No such file or directory" >&2
123 result=1
124 elif test -r "$file"; then
125 test -x "$file" || echo 'ldd:' $"\
126 warning: you do not have execution permission for" "\`$file'" >&2
127 RTLD=
128 for rtld in ${RTLDLIST}; do
129 if test -x $rtld; then
130 verify_out=`${rtld} --verify "$file"`
131 ret=$?
132 case $ret in
133 [02]) RTLD=${rtld}; break;;
134 esac
136 done
137 if test -z "${RTLD}"; then
138 set ${RTLDLIST}
139 RTLD=$1
140 verify_out=`${RTLD} --verify "$file"`
141 ret=$?
143 case $ret in
145 eval $add_env '"$file"' || result=1
148 # This can be a non-ELF binary or no binary at all.
149 nonelf "$file" || {
150 echo $" not a dynamic executable"
151 result=1
155 eval $add_env \${RTLD} '"$file"' || result=1
158 echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($ret)" >&2
159 exit 1
161 esac
162 else
163 echo 'ldd:' $"error: you do not have read permission for" "\`$file'" >&2
164 result=1
166 done
168 exit $result
169 # Local Variables:
170 # mode:ksh
171 # End: